;**********************************************************************************************************************************************************
;**********************************************************************************************************************************************************
;**********************************************************************************************************************************************************
;
;	Program demonstrujcy obsug myszy PS/2 na procesorach rodziny 8051. Tomasz Orowski
;
;**********************************************************************************************************************************************************
;**********************************************************************************************************************************************************
;**********************************************************************************************************************************************************
;
$mod51
;
$NODEBUG
$LIST
$OBJECT
;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
;
RESET			EQU			0000H		; deklarowanie adresw procedur przerwa i startu programu 
EXTI0			EQU			0003H		;
TIMER0		EQU			000BH		;
EXTI1			EQU			0013H		;
TIMER1		EQU			001BH		;
SINT			EQU			0023H		;
;
LNCLK			EQU			P3.2		;
LNDATA		EQU			P3.3		;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
;
			CSEG					; <-co ta dyrektywa znaczy?
;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
;
;  *******************************************************************
;  *******************************************************************
;  ****                                                           ****
;  ****            TECHNICAL PROCESSOR SERVICES                   ****
;  ****                                                           ****
;  *******************************************************************
;  *******************************************************************
;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
			ORG	RESET				;	** RESET(START PROGRAMU)
			LJMP	RESET_SERVICE		;	adres(0000H-0002H) - max.2B
;----------------------------------------------------------------------------------------------------------------------------------------------------------
			ORG     EXTI0			;	** PRZERWANIE INT0 adres(0003H-000AH) - max.7B
								;
								; <- czy tu nie musz doda czyszczenia znacznika przerwania
			JNB	LNDATA , wyk_int0		; Najpierw sprawdzam, czy na lini DATA zosta nadany bit startu, jesli nie ignoruj przerwanie
			RETI					;
wyk_int0:		LJMP	EXTI0_SERVICE		;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
			ORG	TIMER0			;	** PRZERWANIE TIMER0 adres(000BH-0012H) - max.7B
			LJMP	TIM0_SERVICE		;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
			ORG	EXTI1				;	** PRZERWANIE INT1 adres(0013H-001AH) - max.7B
			LJMP	EXTI1_SERVICE		;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
			ORG	TIMER1			;	** PRZERWANIE TIMER1 adres(001BH-0022H) - max.7B
			LJMP	TIM1_SERVICE		;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
			ORG	SINT				;	** PRZERWANIE SERIAL od adresu 0023H - brak ograniczenia
			LJMP	SERI_SERVICE		;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
EXTI0_SERVICE:                                  ; procedura przerwania pochodzcego z INT0
;****************                               ;
petla_int0_0:	JNB	LNCLK , petla_int0_0	; czekam do nastpnego bitu(do nastpnego stanu niskiego na lini CLK)
petla_int0_1:	JB	LNCLK , petla_int0_1	;
								; zaczynam odczytywa bity na lini DATA, LSB pojawia si pierwszy
			JB	LNDATA , bit_0_hi		;
			CLR	P1.0				;
			SJMP	petla_int0_2		;
bit_0_hi:		SETB	P1.0				;
								;
petla_int0_2:	JNB	LNCLK , petla_int0_2	;
petla_int0_3:	JB	LNCLK , petla_int0_3	;
			JB	LNDATA , bit_1_hi		;
			CLR	P1.1				;
			SJMP	petla_int0_4		;
bit_1_hi:		SETB	P1.1				;
								;
petla_int0_4:	JNB	LNCLK , petla_int0_4	;
petla_int0_5:	JB	LNCLK , petla_int0_5	;
			JB	LNDATA , bit_2_hi		;
			CLR	P1.2				;
			SJMP	petla_int0_6		;
bit_2_hi:		SETB	P1.2				;
								;
petla_int0_6:	JNB	LNCLK , petla_int0_6	;
petla_int0_7:	JB	LNCLK , petla_int0_7	;
			JB	LNDATA , bit_3_hi		;
			CLR	P1.3				;
			SJMP	petla_int0_8		;
bit_3_hi:		SETB	P1.3				;
								;
petla_int0_8:	JNB	LNCLK , petla_int0_8	;
petla_int0_9:	JB	LNCLK , petla_int0_9	;
			JB	LNDATA , bit_4_hi		;
			CLR	P1.4				;
			SJMP	petla_int0_10		;
bit_4_hi:		SETB	P1.4				;
								;
petla_int0_10:	JNB	LNCLK , petla_int0_10	;
petla_int0_11:	JB	LNCLK , petla_int0_11	;
			JB	LNDATA , bit_5_hi		;
			CLR	P1.5				;
			SJMP	petla_int0_12		;
bit_5_hi:		SETB	P1.5				;
								;
petla_int0_12:	JNB	LNCLK , petla_int0_12	;
petla_int0_13:	JB	LNCLK , petla_int0_13	;
			JB	LNDATA , bit_6_hi		;
			CLR	P1.6				;
			SJMP	petla_int0_14		;
bit_6_hi:		SETB	P1.6				;
								;
petla_int0_14:	JNB	LNCLK , petla_int0_14	;
petla_int0_15:	JB	LNCLK , petla_int0_15	;
			JB	LNDATA , bit_7_hi		;
			CLR	P1.7				;
			SJMP	petla_int0_16		;
bit_7_hi:		SETB	P1.7				;
								;
petla_int0_16:	JNB	LNCLK , petla_int0_16	; bit parzystoci nie jest mi potrzebny, wic czekam na nastpny
petla_int0_17:	JB	LNCLK , petla_int0_17	;
								;
petla_int0_18:	JNB	LNCLK , petla_int0_18	; bit stopu musi by rwny 1, jeli nie jest, oznacza to, e bajt jest le odebrany
petla_int0_19:	JB	LNCLK , petla_int0_19	;
			JB	LNDATA , bit_stop_ok	;
			MOV	P1 , # 000H			; bad odbioru!
			SJMP	bit_end			;
bit_stop_ok:	SETB	C				; Flaga C=1 oznacza, e odebrano bajt poprawnie
								;
bit_end:		RETI					;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
TIM0_SERVICE:                                   ; procedura przerwania pochodzcego z TIMER0
;****************                               ;
			RETI					;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
EXTI1_SERVICE:                                  ; procedura przerwania pochodzcego z INT1
;****************                               ;
			RETI					;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
TIM1_SERVICE:                                   ; procedura przerwania pochodzcego z TIMER1
;****************                               ;
			RETI					;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
SERI_SERVICE:                                   ; procedura przerwania pochodzcego z SERIALa
;****************                               ;
			RETI					;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
;
;  *******************************************************************
;  *******************************************************************
;  ****                                                           ****
;  ****                    SOFTWARE START                         ****
;  ****                                                           ****
;  *******************************************************************
;  *******************************************************************
;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
RESET_SERVICE:                                  ;
			CLR	P3.7				; wczam zasilanie myszy
								; po wczeniu mysz jako pierwsza zaczyna nadawa dane. Dane s nadawane synchronicznie z sygnaem
								; zegarowym na lini CLK. To mysz generuje sygna zegarowy na lini CLK. Mysz zapisauje bit na lini
								; DATA kiedy na lini zegarowej CLK jest stan wysoki, host odczytuje go, kiedy na lini zegarowej
								; CLK jest stan niski.
			MOV	IE , # 010000001B		; zezwalam na przerwania pochodzce z nki /INT0(stan niski powoduje przerwanie)
petla:		SJMP	petla				;
;----------------------------------------------------------------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------------------------------------------------------------
;
                END
